-- This file was generated with xrom written by Daniel Wallner

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity BASIC-52 is
	port(
		Clk	: in std_logic;
		A	: in std_logic_vector(11 downto 0);
		D	: out std_logic_vector(7 downto 0)
	);
end BASIC-52;

architecture rtl of BASIC-52 is
	component RAM16X1S
		port(
			O    : out std_ulogic;
			A0   : in std_ulogic;
			A1   : in std_ulogic;
			A2   : in std_ulogic;
			A3   : in std_ulogic;
			D    : in std_ulogic;
			WCLK : in std_ulogic;
			WE   : in std_ulogic);
	end component;

	component RAMB4_S8
		port(
			DO     : out std_logic_vector(7 downto 0);
			ADDR   : in std_logic_vector(8 downto 0);
			CLK    : in std_ulogic;
			DI     : in std_logic_vector(7 downto 0);
			EN     : in std_ulogic;
			RST    : in std_ulogic;
			WE     : in std_ulogic);
	end component;

	signal A_r: unsigned(A'range);
	type sRAMOut_a is array(0 to 95) of std_logic_vector(D'range);
	signal sRAMOut : sRAMOut_a;
	signal siA_r : integer;
	signal sD : std_logic_vector(D'range);
	type bRAMOut_a is array(3 to 7) of std_logic_vector(7 downto 0);
	signal bRAMOut : bRAMOut_a;
	signal biA_r : integer;
	signal bD : std_logic_vector(D'range);
begin
	process (Clk)
	begin
		if Clk'event and Clk = '1' then
			A_r <= unsigned(A);
		end if;
	end process;

	siA_r <= to_integer(A_r(A'left downto 4));

	sG1: for I in 0 to 95 generate
		sG2: for J in 0 to 7 generate
			SBASIC-52 : RAM16X1S
				port map (WE => '0', WCLK => '0', D => '0', O => sRAMOut(I)(J), A0 => A_r(0), A1 => A_r(1), A2 => A_r(2), A3 => A_r(3));
		end generate;
	end generate;

	process (siA_r, sRAMOut)
	begin
		sD <= sRAMOut(0);
		for I in 1 to 95 loop
			if siA_r = I then
				sD <= sRAMOut(I);
			end if;
		end loop;
	end process;

	biA_r <= to_integer(A_r(A'left downto 9));

	bG1: for I in 3 to 7 generate
		bG2: for J in 0 to 0 generate
			BBASIC-52 : RAMB4_S8
				port map (DI => "00000000", EN => '1', RST => '0', WE => '0', CLK => Clk, ADDR => A(8 downto 0), DO => bRAMOut(I)(7 + 8 * J downto 8 * J));
		end generate;
	end generate;

	process (biA_r, bRAMOut)
	begin
		bD <= bRAMOut(3)(D'range);
		for I in 4 to 7 loop
			if biA_r = I then
				bD <= bRAMOut(I)(D'range);
			end if;
		end loop;
	end process;

	D <= bD when A_r(A'left downto 9) >= 3 else sD;
end;
