#!/usr/bin/python

import string

# Eingabedatei
f = file('ROM52_BASIC.vhd', 'r') 
lines = f.readlines()
f.close()

# Ausgabedatei
f_out = file('ROM52_BASICX.vhd', 'w')



vorspann = """
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity ROM52 is
        port(
		Clk     : in std_logic;
		A       : in std_logic_vector(12 downto 0);
		D	: out std_logic_vector(7 downto 0)
	);
end ROM52;

architecture rtl of ROM52 is
	signal A_r : std_logic_vector(12 downto 0);
    	type rom_type is array (0 to 8191) of std_logic_vector (7 downto 0);
	constant ROM : rom_type :=(
"""
abspann = """
                   );
begin
    process (Clk)
    begin
        if (Clk'event and Clk = '1') then
                 A_r <= A;
        end if;
    end process;
    D <= ROM(to_integer(unsigned(A_r)));
end rtl;
"""



f_out.writelines(vorspann)
f_out.writelines("\t\t")

#f_out.writelines("\n")

count = 0
for line in lines:
	# nur die Zeilen mit "when" betrachten
	if string.find( line, "when") >= 0:
    		line_split = line.split('"')

		# Wert ausgeben
		if count < 8192:
			f_out.writelines("\"%s\"" % line_split[1])

		# bis auf das Letzte ein Komma anhaengen
		if count < 8191:
			f_out.writelines(", ")

		f_out.writelines("-- 0x%04X\n\t\t" % count)
		# alle 4 Ausgaben ein Zeilenumbruch
#		if (count % 4 == 3) and (count < 8191):
#			f_out.writelines("\n\t\t")
		count += 1

f_out.writelines(abspann)
f_out.close()
